#include "jpeglib.h"
/***************************************************************************/

/*
 * 2-d Forward DCT for Hardware implementaion
 * The ouput is 1/4 the definition of 2D DCT	
 */
#define SCALE_FACTOR 10
#define SCALE (1<<SCALE_FACTOR)  // SCALE= 2^SCALE_FACTOR
#define INV_SQTR_2_DIV16 (int)(45)
#define INV2_SQTR_2_DIV16 (double)(0.044194174)
#define DIV16 (int)(SCALE*(1/16.0))
#define DIV32 (int)(SCALE*(1/32.0))
#define SCALE_DIV2 (SCALE/2)

int COS[32]={1024, 1004, 946, 851, 724, 568, 391, 199, 0, -199, -391, -568, -724, -851, -946, -1004, -1024, -1004, -946, -851, -724, -568, -391, -199, 0, 199, 391, 568, 724, 851, 946, 1004};

void dct2dhardware() {
  short x,y,n,m,ptr;
  int i;
  DCTELEM data[DCTSIZE2];
  DCTELEM data2[DCTSIZE][DCTSIZE];
  int tmp;
  int tmp2;
  int cpt=0;
  int etat;
  while(cpt++<(((IMAGE_WIDTH*IMAGE_HEIGHT)/DCTSIZE2)*3)){

    Read_From_FIFO2(data);
    for(i=0;i<4096;i++){
  
      y= (i >> 9)&0x7;
      x= (i >> 6)&0x7;
      n= (i >> 3)&0x7;
      m= (i >> 0)&0x7;
      ptr = i&0x3F;
 

      if (m==0 && n==0) {
	tmp = data[ptr]*COS[(x*(2*m+1))&0x1F]*COS[(y*(2*n+1))&0x1F];
      } else {
	tmp = tmp + data[ptr]*COS[(x*(2*m+1))&0x1F]*COS[(y*(2*n+1))&0x1F];
      }
      if (m==7 && n==7) {
	tmp=(tmp>>SCALE_FACTOR);
	if(x==0&&y==0) {
	  data2[y][x] = (((tmp*DIV32)>>SCALE_FACTOR) + SCALE_DIV2)>>SCALE_FACTOR;
	  
	} else if (x==0||y==0) {
	  data2[y][x] = (((tmp*INV_SQTR_2_DIV16)>>SCALE_FACTOR)+ SCALE_DIV2)>>SCALE_FACTOR;
	  
	} else {
	  data2[y][x] = (((tmp*DIV16)>>SCALE_FACTOR) + SCALE_DIV2 )>>SCALE_FACTOR;
	 
	}
      }  
      
    }
    Write_In_FIFO3(data2);
    
  }
  while(1){OSTimeDlyHMSM(0,0,0,100);}
}
