#include "jpeglib.h"
#include "image.h"

/* fonction chargee de decouper l'image en bloc de 8*8 pixel */

void decoupe_block ()
     /* This version is used for integer DCT implementations. */
{
 
  JSAMPLE workspace[DCTSIZE2*3];	/* work area for FDCT subroutine */
  JDIMENSION start_row;
  JDIMENSION start_col;
  JSAMPROW elemptr;
  JSAMPLE elemr;
  JSAMPLE row;
  JSAMPLE col;
  int cpt=0;
  INT32U begin_time,end_time;
  int top;
  begin_time=OSTimeGet();
  for (start_row = 0; start_row < IMAGE_HEIGHT ; start_row += DCTSIZE) {
    for (start_col=0; start_col < 3*IMAGE_WIDTH; start_col += 3*DCTSIZE) {
      
      /* Load data into workspace, applying unsigned->signed conversion */
      
      row=(JSAMPLE)start_row;
      col=(JSAMPLE)start_col;
      int i;
      for (elemr = 0; elemr < DCTSIZE; elemr++) {
	elemptr = image + elemr*3*IMAGE_WIDTH+col +row*3*IMAGE_WIDTH;
	
	for (i=0;i<3*DCTSIZE;i++){
	  
	  workspace[elemr*DCTSIZE+i] = GETJSAMPLE(*elemptr++) - CENTERJSAMPLE;
	}
      }
      /* envoi d'un bloc a la transformation de couleur */
      Write_In_FIFO1(workspace);
      if((cpt++)%5==0){
        printf("block decoupe %d / 255\n",cpt);
      }
    }
  }
  printf("decoupage fini\n");
  Read_From_FIFO4(&top);
  end_time=OSTimeGet();
  printf("temps d'execution : %d\n",end_time-begin_time);
}

