#include "jpeglib.h"

static unsigned int std_luminance_quant_tbl[DCTSIZE2] = {
  16,  11,  10,  16,  24,  40,  51,  61,
  12,  12,  14,  19,  26,  58,  60,  55,
  14,  13,  16,  24,  40,  57,  69,  56,
  14,  17,  22,  29,  51,  87,  80,  62,
  18,  22,  37,  56,  68, 109, 103,  77,
  24,  35,  55,  64,  81, 104, 113,  92,
  49,  64,  78,  87, 103, 121, 120, 101,
  72,  92,  95,  98, 112, 100, 103,  99
};

static unsigned int std_chrominance_quant_tbl[DCTSIZE2] = {
  17,  18,  24,  47,  99,  99,  99,  99,
  18,  21,  26,  66,  99,  99,  99,  99,
  24,  26,  56,  99,  99,  99,  99,  99,
  47,  66,  99,  99,  99,  99,  99,  99,
  99,  99,  99,  99,  99,  99,  99,  99,
  99,  99,  99,  99,  99,  99,  99,  99,
  99,  99,  99,  99,  99,  99,  99,  99,
  99,  99,  99,  99,  99,  99,  99,  99
};

void init_quant_tables()
{
  int i;
  for (i = 0; i < DCTSIZE2; i++) {
    std_luminance_quant_tbl[i] = ((DCTELEM) std_luminance_quant_tbl[i]) << 3;
    std_chrominance_quant_tbl[i] = ((DCTELEM) std_chrominance_quant_tbl[i]) << 3;
  }
}

void quantization()
{
  
  DCTELEM workspace[DCTSIZE2];	
  int type=0;
  int top=1;
  DCTELEM * divisors;
  JCOEF output_ptr[DCTSIZE2];
  init_quant_tables();
  printf("Tables initialisees\n");
  while(type<(((IMAGE_WIDTH*IMAGE_HEIGHT)/DCTSIZE2)*3)){
    Read_From_FIFO3(workspace);
    if((type%3)==0){
      divisors = std_luminance_quant_tbl;
      type++;
    }else{
      divisors = std_chrominance_quant_tbl;
      type++;
    }
    
    
    { 
      DCTELEM temp, qval;
      
      int i;
     
      
      for (i = 0; i < DCTSIZE2; i++) {
	qval = divisors[i];
	temp = workspace[i];
	
	if (temp < 0) {
	  temp = -temp;
	  temp += qval>>1;	
	  temp/=qval;
	  temp = -temp;
	} else {
	  temp += qval>>1;	
	  temp/=qval;
	}
	output_ptr[i] = (JCOEF) temp;
      }
    }

  }
  printf("quantification finie\n");
  Write_In_FIFO4(&top);
}

